#!/usr/bin/perl

# the main WebThread program, freeware version
# $Id: FreeThread.pl,v 25.3.1.1 1996/10/06 16:54:00 dmacks Rel $

# WebThread, a hacked together cgi-bin thingy by Daniel Macks
# This file copyright (c) 1996 by Emaze Software Corp. and Daniel Macks.
# All rights reserved. See the file COPYRITE for more information.

BEGIN {				
	# set up mission-critical things first
	unless (defined $SL) {
		if (-d '\\') {		# 'doze? (VMS??)
			$SL='\\';
		} elsif (-d '/') {	# unicycle? (WinNT already caught)
			$SL='/';
		} elsif (-d ':') {	# mac?
			$SL=':';
		} else {
			print "Could not determine server info!\n";
			die("WebThread could not determine \$SL!\n");
		};
	};

	my $mylib = "$ENV{'projectDIR'}${SL}lib";	# our added lib
	unshift (@INC,"$mylib");			# general needed libs
	unshift (@INC,"$mylib${SL}WT${SL}compat_NT") if $SL eq '\\';	# ack!

	$treeDIR="$ENV{'projectDIR'}${SL}msgtree1";
	$dbperms=0666;
	$dirperms=0777;
};

($version='$Revision: 25.3.1.1 $$Date: 1996/10/06 16:54:00 $')=~s/\$\w*:?//g;

use CGI;
$query=new CGI;
$myURL=$query->url.$ENV{'PATH_INFO'};

$|=1;		# force flush after each print, so httpd doesn't timeout
		# the connection even if script takes a while to run

# the presence of a file called 'nologin' in $ENV{'projectDIR'} or
# $treeDIR disables WebThread, and returns the contents of the
# 'nologin' file (like /etc/nologin)

if (-e "$ENV{'projectDIR'}${SL}nologin") {
        print $query->header(-status=>'200 OK');
	&CatFile("$ENV{'projectDIR'}${SL}nologin") if (-r _);
	exit 1;
};

if ( -e "$treeDIR${SL}nologin") {
        print $query->header(-status=>'200 OK');
	&CatFile("$treeDIR${SL}nologin") if (-r _);
	exit 1;
};

use WT::errors;
use WT::pass "$treeDIR";
use WT::auth "$treeDIR";
use WT::ticket;

$extPost="$treeDIR${SL}ext-post.pl";
$isExtPost=(-r "$extPost");		# external posting routine?

umask(0000);	# b/c htpd runs as uid=http/gid=http, but I want to be
		# able to access files as well.
		# could probably do umask(0077) in production
		# giving only root access to files, or if also suid
		# give that user acess to files

$loginHTML="login.html";		# an html fragment in $treeDIR
$introHTML="intro.html";		# an html fragment in $treeDIR
$addHTML="add.html";			# an html fragment in $treeDIR

$docDIR="doc";				# a directory in $ENV{'projectDIR'}

$defreadform='indxmsgs';		# default readform: should be
					# 'indx' or 'msgs' or 'indxmsgs'

# now about those pesky dbm files...
use Fcntl qw(O_CREAT O_RDWR O_RDONLY);
use SDBM_File;
use flocker;

$userDB="$treeDIR${SL}users";
unless (&flocker::NewLockfile($userDB)) {
	&ErrServ("cannot secure userDB");
	&LogWarn($flocker::msg);
	&End;
};

$threadDB="$treeDIR${SL}threads";
unless (&flocker::NewLockfile($threadDB)) {
	&ErrServ("cannot secure threadDB");
	&LogWarn($flocker::msg);
	&End;
};

$msgDB="msgs";				# a DBM in each msgTUB
$markDB="marks";			# a DBM in each msgTUB

$timestamp=sprintf("%d-%.5d",$^T,$$);

#use POSIX qw(strftime);	# a pain to get on NT so need a dumb hack
if ($CGI::OS ne 'NT') {
	require "POSIX.pm";
} else {
	@days=qw(Sun Mon Tues Wed Thurs Fri Sat);
	@months=qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
};
sub strftime {	# hand off to POSIX::strftime() if we found POSIX, else fake it
	my $format = shift;
	if ($INC{'POSIX.pm'}) {
		POSIX::strftime($format,@_);
	} elsif ($format eq $msgtimestamp) {
		sprintf "%s, %s %.2d, %.4d at %.2d:%.2d %.2s",
			$days[$_[6]],$months[$_[4]],$_[3],$_[5]+1900,
			$_[2]%12,$_[1],($_[2]>11?'PM':'AM');
	} elsif ($format eq $shorttimestamp) {
		sprintf "%.2d/%.2d/%.2d",@_[4,3,5];
	} else {
		die "must preconfigure NT strftime hack for all formats\n";
	};
}

$msgtimestamp="%a, %B %d, %Y at %I:%M %p";	# strftime format
$shorttimestamp="%m/%d/%y";			# strftime format

&CGI::ReadParse;
&Setup;

if ($in{'ticket'}) {
	unless ($uid=&ValidTicket($in{'ticket'})) {
		&ErrHack("Your ticket is invalid","You must <a href=\"$myURL\">login</a> before using WebThread");
		&LogHack("Invalid ticket: $in{'ticket'}");
		&End;
	};
} else {
	if ($ENV{'WTlogin_name'}) {	# wedged login?
		$in{'login-name'}=$ENV{'WTlogin_name'};
		$in{'login-pass'}=$ENV{'WTlogin_pass'};
	};
	if ($in{'login-name'}) {
		&PWCheck($in{'login-name'},$in{'login-pass'},"login");
		$uid=&LookupUID($in{'login-name'});
	} else {
		&OutputTop('login');
		&OutputLogin;
		&OutputBot(1);
		&End;
	};
};

%auth=&AuthAAFromNum(&MaskAuth($uid,&GetAuth($uid)));

if ($in{'threadID'}=~/\D/) {
	&ErrHack("invalid threadID");
	&LogHack("user passed bad \$threadID");
	&End;
};

unless ($auth{'access'}) {
	&ErrUser("I'm sorry, you are not permitted to use WebThread.");
	&LogHack("denied-access user tried to login");
	&End;
};	

($function)=grep(/^function\//,keys(%in));	# get name
$function=~s/^function//;			# parse it
$function=~s/\..$//;				# deal with type=img

if ($function eq '') {
	&OutputTop('main');
	&CatFile("$treeDIR$SL$introHTML");
	&OutputReadThread if $auth{'read'};
	&OutputBeginNew if $auth{'new'};
	&OutputMainOpts;
	&OutputBot(0);
} elsif ($function eq '/help') {
	my($special)=($auth{'admin'} || $auth{'superuser'});
	my($faqfile)=($special ? 'faq-admin.html' : 'faq-user.html');
	$special ? &OutputTop('user help') : &OutputTop('administrator help');
	&OutputNavButtons;
	print "<hr noshade size=3>\n";
	&CatFile("$ENV{'projectDIR'}$SL$docDIR$SL$faqfile");
	&OutputReadThread;
	&OutputBot(0);
} elsif ($function eq '/mplex') {
	$ENV{'PATH_INFO'}='';	# so multiplexer doesn't send us back here
	require "$multiplexer";	# go there now, dude!
} elsif ($function=~/^\/admin/) {
	unless ($auth{'admin'}) {
		&ErrHack("you are not an admin");
		&LogHack("user not authorized to do /admin");
		&End;
	};

	if ($function eq '/admin/susres') {
		&Action_susres;
	} elsif ($function eq '/admin/delete') {
		&Action_delete;
	} elsif ($function ne '/admin') {
		&ErrUser("invalid action requested");
		&End;
	};
	&OutputTop('admin');
	&OutputAdmin;
	&OutputBot(0);
} elsif ($function eq '/post') {
	unless ($auth{'post'}) {
		&ErrHack("you are not authorized to post");
		&LogHack("user not authorized to do /post");
		&End;
	};

	unless ($in{'threadID'}=~/\d+/) {
		&ErrUser("you must select whether your response should continue in the current thread or a new thread");
		&End;
	};

	if ($in{'messagetext'} eq '') {
		&ErrUser("you cannot post a blank message");
		&End;
	};

	if ($in{'threadID'}==0) {	# new thread
		unless ($auth{'new'}) {
			&ErrHack("you are not authorized to begin new threads");
			&LogHack("user not authorized to begin new thread (/post)");
			&End;
		};

		if ($in{'newthreadsubject'} eq '') {	# thread selected?
			&ErrUser("you must give this new thread a title");
			&End;
		};

		&CreateThread;

		if ($in{'sourcethreadID'}) {
			$post{'summary'}='';
			$post{'msg'}='';
			&PostMessageCheck($in{'sourcethreadID'},"C-$in{'threadID'}",%post);
		};

	};		# fall through into regular posting

	&EscapeHTML($in{'messagesummary'});
	$post{'summary'}=$in{'messagesummary'};

	&EscapeHTML($in{'messagetext'});

	if ($useAnonUser) {	# deal with the extra crap
		&EscapeHTML($in{'uAUname'});
		&EscapeHTML($in{'uAUemail'});

		my $anonlink = $in{'uAUname'} || "anonymous";
		$anonlink = "<a href=\"mailto:$in{'uAUemail'}\">$anonlink</a>" if $in{'uAUemail'};
		$post{'msg'}  = "</p>Posted by $anonlink</p>\n";
		$post{'msg'} .= $in{'messagetext'};
	} else {
		$post{'msg'}  = $in{'messagetext'};
	};

	&PostMessageCheck($in{'threadID'},"N",%post);
	$threadDB{$in{'threadID'},"timelast\0"}=$timestamp;
	require "$extPost" if $isExtPost;

	&ReadThread($in{'threadID'});	# can always read after post
					# even if !$auth{'read'}

} elsif ($function eq '/read') {
	unless ($auth{'read'}) {
		&ErrHack("you are not authorized to read threads");
		&LogHack("user not authorized to do /read");
		&End;
	};

	unless ($in{'threadID'}>0) {	# thread selected?
		&ErrUser("please select a thread to read");
		&End;
	};
	if ($threadDB{$in{'threadID'},"status\0"}<=0) {
		&ErrUser("that thread is inactive or has been removed from the server");
		&End;
	};

	&ReadThread($in{'threadID'});

} elsif ($function eq '/unpost') {
	unless ($auth{'admin'} || $auth{'unpost'}) {
		&ErrHack("you are not authorized to unpost");
		&LogHack("user not authorized to do /unpost");
		&End;
	};

	&Action_unpost($in{'threadID'},$in{'msgID'});

	&ReadThread($in{'threadID'});

} elsif ($function=~/^\/user/) {
	unless ($auth{'user'} || $auth{'superuser'}) {
		&ErrHack("you may not modify userDB entry");
		&LogHack("user not authorized to do /user");
		&End;
	};

	my(%targetuids);			# remove duplicate selections
	grep( $targetuids{$_}++, split( "\0", $in{'targetuid'} ) );
	delete $targetuids{0};	# "none" (space) above first in each <select>
	delete $targetuids{''};	# if uid <input> is blank
	unless (%targetuids) {
		&ErrUser("you did not select any users to edit");
		&End;
	};

	$in{'targetuid'}=join("\0", sort keys %targetuids );

	if (%targetuids>1) {
		&ErrWarn("you cannot select more than one user to edit");
		&End;
	};

	if ($in{'targetuid'}!=$uid && !$auth{'superuser'}) {
		&ErrHack("you may not edit someone else");
		&LogHack("user not authorized to edit others");
		&End;
	};

	if ($function eq '/user/set') {
		&Action_set;
	} elsif ($function ne '/user') {
		&ErrUser("invalid action requested");
	};

	&OutputUser($in{'targetuid'});

} elsif ($function=~/^\/adduser/) {
	unless ($auth{'adduser'}) {
		&ErrHack("you are not authorized to add users");
		&LogHack("user not authorized to do /adduser");
		&End;
	};

	if ($function eq "/adduser") {
		&OutputTop('add user');
		&OutputAddUser;
		&OutputBot(0);
	} elsif ($function eq "/adduser/new") {
		&SetNumFromCB('auth');
		if ( !$auth{'superuser'} && ( $in{'auth'} ne &GetAuth('default') ) ) {
			&ErrHack("you are not permitted to change that field");
			&LogHack("user attempted to change the userDB:auth field");
			&End;
		};
		&AddUser;
		&OutputTop('add user');
		&OutputUserAdded;
		&OutputBot(0);
	} else {
		&ErrUser("invalid action requested");
	};


} elsif ($function eq '/superuser') {
	unless ($auth{'superuser'}) {
		&ErrHack("you are not a superuser");
		&LogHack("user not authorized to do /superuser");
		&End;
	};
	&OutputTop('superuser');
	&OutputSuperUser;
	&OutputBot(0);

} elsif ($function=~/^\/ticklist/) {
	unless ($auth{'superuser'} || $auth{"admin"}) {
		&ErrHack("you are not a superuser or admin");
		&LogHack("user not authorized to do /ticklist");
		&End;
	};

	my $expdt = -1;		# assume no expiration

	if ($function eq "/ticklist/nuke") {
		unless ($in{'expdt'}=~/^\d+$/) {
			&ErrUser("invalid ticket age specified");
			&End;
		};
		$expdt=$in{'expdt'};
	} elsif ($function ne '/ticklist') {
		&ErrUser("invalid action requested");
		&End;
	};

	&main::OutputTop('ticket registry');
	&OutputTicketRegistry($expdt);
	&OutputFormTag;
	&OutputButton('Tlist','/ticklist');
	print " Update registry list<br>";
	&OutputButton('Tnuke','/ticklist/nuke');
	print " Destroy tickets older than ";
	print "<input name=expdt size=3 maxlength=3>";
	print " hours<br></form>\n";

	&OutputBot(0);


} elsif ($function=~/^\/globalauth/) {
	unless ($auth{'superuser'}) {
		&ErrHack("you are not a superuser");
		&LogHack("user not authorized to do /globalauth");
		&End;
	};

	if ($function eq "/globalauth/setauthdefs") {
		&SetAuthDefs;
	} elsif ($function ne "/globalauth") {
		&ErrUser("invalid action requested");
		&End;
	};
	&OutputTop('global authorizations');
	&OutputGlobalAuths;
	&OutputBot(0);
} elsif ($function=~/^\/logout/) {
	&DeleteTicket($in{'ticket'});
	print $query->redirect($exitURL);
} elsif ($function=~/^\/login/) {
	if ($lnf_mplex) {	# hand back to multiplexer if there is one
		print $query->redirect($query->url);
	} else {		# do it from here
		&DeleteTicket($in{'ticket'});
		&OutputTop('login');
		&OutputLogin;
		&OutputBot(1);
	};
} else {
	&ErrUser("invalid action requested");
};

&End;

###
### subroutines
###

### subroutines ###
# make and break DBM association for %threads
###################

# structure of %threadDB:
#	countall\0		all kinds of threads (max serial number)
#	count+++\0		active threads
#	count---\0		inactive threads
#	count000\0		deleted threads
#	[threadID]^\status\0	integer
#					value=number of posts
#					0: deleted
#					>0: active
#					<0: inactive
#	[threadID]^\source\0	threadID from which /post was called (0 if new)
#	[threadID]^\timefirst\0	timestamp (ctime-pid) of first user post
#	[threadID]^\timelast\0	timestamp (ctime-pid) of last user post
#	[threadID]^\subject\0	subject of thread
#

# structure of %userDB:
#	count\0			number of uids
#	[uid]^\name\0		full name
#	[uid]^\email\0		email address
#
sub Setup {
	&flocker::flockEX($threadDB);
	unless (tie %threadDB,SDBM_File,"$threadDB",O_CREAT|O_RDWR,$dbperms) {
		&flocker::flockUN($threadDB);
		&ErrServ("cannot access threadDB");
		&LogWarn("could not access threadDB: $!");
		&End;
	};

	&flocker::flockEX($userDB);
	unless (tie %userDB,SDBM_File,"$userDB",O_CREAT|O_RDWR,$dbperms) {
		&flocker::flockUN($userDB);
		untie %threadDB;
		&flocker::flockUN($threadDB);
		&ErrServ("cannot access userDB");
		&LogWarn("could not access userDB: $!");
		&End;
	};

	if ($init) {			# gonna make a new conference

		if (defined $threadDB{"countall\0"}) {
			&ErrUser("conference already exists--you cannot reinstall it");
			&LogWarn("\$init=1 but threadDB already exists");
			&End;
		};

		$threadDB{"countall\0"}=0;
		$threadDB{"count+++\0"}=0;
		$threadDB{"count---\0"}=0;
		$threadDB{"count000\0"}=0;

		my($Muser,$Mpw);
		if (!&NumUsers) {	# create master acct if no users
			($Muser,$Mpw)=('master',($^T*$$));
			$in{'user'}=$Muser;
			$in{'pw1'}=$in{'pw2'}=$Mpw;
			$in{'auth'}=&FullAuth;
			&AddUser;
		} else {		# or extend full auth into new authDB
			&SetAuth(1,&FullAuth);
			$Muser=&LookupUname(1);
		};

		$in{'no-gen-ticket'}='ON';

		&OutputTop('initialization');
		print <<EOHTML;
<p><b>WebThread</b> system has been initialized. A new conference has 
been created. You must now set the <code>\$init</code> variable in the 
configuration file to false. Installation will then be complete.</p>
<pre>
   Conference name  : &quot;$lnf_name&quot;
   WebThread kernel : $version
EOHTML

		print "   URL to access    : ",$myURL,"\n</pre>\n";

		if ($Mpw) {
			print <<EOHTML;
<p>A single user with full authorization has been created. Using the 
username and password listed below, you will be able to log in and add 
users as necessary.</p>
<pre>
   username:  $Muser
   password:  $Mpw
</pre>
EOHTML
		} else {
			print <<EOHTML;
<p>The pre-existing master user (uid 1) has been given full 
authorization in this conference.</p>
<pre>
   username: $Muser
   password not changed
</pre>
EOHTML
		};
		print $query->end_html;
		&End;
	};

}

sub End {
	untie %threadDB;		# close threadDB dbm
	&flocker::flockUN($threadDB);	# just to be sure
	untie %userDB;			# close userDB dbm
	&flocker::flockUN($threadDB);	# just to be sure
	exit 1;				# thanks for playing
}

### subroutines ###
# standard parts of non-error-message pages
###################

sub OutputTop {
	my(@bodyspecs);
	@bodyspecs=('-title',"WebThread \"$lnf_name\" $_[0]");
	grep(unshift(@bodyspecs,"-$_",$lnf_bodytag{$_}),keys %lnf_bodytag);
	print $query->header(-status=>'200 OK');
	print $query->start_html(@bodyspecs);
}

sub OutputBot {			# links to get out; copyright notice
	my($nonav)=@_;
	unless ($nonav) {
		print "<hr noshade size=3>\n";
		&OutputNavButtons;
	};
	print <<EOHTML;
<!--
This page generated by WebThread kernel $version
WebThread copyright &copy; 1996 by Emaze Software Corp. and Daniel Macks.
-->

EOHTML
    print $query->end_html;
}

sub OutputButton {
	my($button,$name)=@_;
	$name=" name=\"function$name\"" if defined $name;
	print "<input type=submit $name value=\"$lnf_button{$button}\">";
}

sub OutputNavButtons {
	my $hasLogin = ($lnf_button{'Nlogin'} && !$useAnonUser);
	my $count = 1;	# always have logout
	$count++ if $lnf_button{'Nmain'};
	$count++ if $lnf_button{'Nmplex'}=$lnf_mplex;
	$count++ if $hasLogin;
	$count++ unless $function eq '/help';
	local $td = sprintf '<td width="%d%%" align=center>',(100/$count + 0.5);

	print "<center><table width=\"90%\"><tr><td>\n";
	&OutputFormTag;		# Nutscape screws spacing if not in the table

	print ($td),&OutputButton('Nmain','') if $lnf_button{'Nmain'};
	print ($td),&OutputButton('Nmplex','/mplex') if $lnf_button{'Nmplex'};
	print ($td),&OutputButton('Nlogout','/logout');
	print ($td),&OutputButton('Nlogin','/login') if $hasLogin;
	print ($td),&OutputButton('Nhelp','/help') unless $function eq '/help';

	print "<td></form></table></center>\n";	# another Nutscape spacig hack
}

sub OutputUser {	# $_[0]=uid to display

	my($targetuid)=$_[0];
	my($targetuname)=&LookupUname($targetuid);

	if ($targetuid=~/\D/ || !$targetuid || $targetuid>&NumUsers) {
		&ErrHack("unknown user");
		&LogHack("attempted to edit userDB for unknown uid $_[0]");
		&End;
	};

	&OutputTop("user editor ($targetuname)");

	print <<EOHTML;
<center>
<h2>WebThread user information editor</h2>
</center>

<p>Edit you user information in the fields below. If you do not wish to 
change the password, leave both &quot;password&quot; fields blank. If you 
enter anything in either &quot;password&quot; field, your password will be 
changed. Note that you must enter your password twice to verify that you 
have entered it correctly, and that passwords are case-sensitive.</p>

<p>If you make a mistake, click &quot;reset&quot; to bring back the 
currently saved information. Note that the password you enter to submit 
your changes is <i>your old password</i> (not a new one you assign on 
this page).</p>

When you are done, enter your password (if you are changing your 
password, enter your <i>old</i> one), and click 
&quot;update&quot;.</p>

<hr noshade size=3>
<pre>
EOHTML

	&OutputFormTag;
	print "   username:  ";
	if ($auth{'superuser'}) {
		print "<input name=user value=\"$targetuname\">\n";
	} else {
		print "$targetuname<input type=hidden name=user value=\"$targetuname\">\n";
	};
	print <<EOHTML;

   password:  <input type=password name=pw1>
              <input type=password name=pw2> (re-enter to verify)

EOHTML
	print "   uid:       $targetuid" if $auth{'superuser'};
	print "<input type=hidden name=targetuid value=$targetuid>\n\n";
	&OutputAuthFlags($auth{"superuser"},$targetuid);
	print <<EOHTML;

   name:      <input name=name value="$userDB{$targetuid,"name\0"}" size=40>

   email:     <input name=email value="$userDB{$targetuid,"email\0"}" size=40>
</pre>

<hr>
<table width="100%"><tr>
<td align=left>your password: <input type=password name=passwd>

EOHTML
	&OutputButton('Uchange','/user/set');
	print "<input type=reset value=reset><td></form>\n";
	if ($auth{'superuser'}) {
		print "<td align=right>";
		&OutputFormTag;
		&OutputButton('Usuperuser','/superuser');
		print "<td></form>\n";
	};
	print "</table>\n";
	&OutputBot(0);
}

### subroutines ###
# other general sections of pages
###################

sub OutputMsgArea {
	print "Summary: <input name=messagesummary size=50 maxlength=50>\n";
	print "<br>\n";
	if ($useAnonUser) {
		print "name: <input name=uAUname size=40><br>\n";
		print "email: <input name=uAUemail size=40><br>\n";
	};
	print "<textarea name=messagetext rows=7 cols=70></textarea><br>\n";
	&OutputButton('post','/post');
	print "<input type=reset value=clear><br>\n";
}

sub OutputReadThread {	# $_[0]=threadID
	my($readform)=($in{'readform'} || $defreadform);
	print "<hr noshade size=3>\n";
	&OutputFormTag;
	print "<a name=\"read\"></a><h2>Read a thread ";
	print "</h2>\n";

	if ($threadDB{"count+++\0"}) {
		&ThreadMenu(1,"threadID",$_[0]);
		print "<select name=readform>\n";
		print "<option value=msgs";
			print " selected" if $readform eq 'msgs';
			print ">messages only\n";
		print "<option value=indx";
			print " selected" if $readform eq 'indx';
			print ">index only\n";
		print "<option value=indxmsgs";
			print " selected" if (($readform eq 'msgsindx') || ($readform eq 'indxmsgs'));
			print ">index and messages\n";
		print "</select>\n";
		&OutputButton('read','/read');
		print "</form></table>\n";

	} else {
		print "no threads to read<br>\n";
	};
	print "</form>\n";
}

sub ThreadMenu {
	my($statusreq)=$_[0];	# status sign for selecting threads
	my($fieldname)=$_[1];	# html input field name
	my($selopts)=$_[2];	# default selection or "multiple"
	my($status);		# saves time in <select> loop
	my($menu)=0;		# is there actually a menu?

	for($i=$threadDB{"countall\0"};$i;$i--) {
		$status=$threadDB{$i,"status\0"};
		if ( ($status>0 && $statusreq>0) || ($status==0 && $statusreq==0) || ($status<0 && $statusreq<0) ) {

			if (!$menu) {
				$menu=1;
				print "<select name=$fieldname";
				print " $selopts" if $selopts=~/multiple/;
				print ">\n";
			};

			print "<option value=$i";
			print " selected" if $i==$selopts;
			print ">",$threadDB{$i,"subject\0"},"\n";
		};
	};

	print "</select>\n" if $menu;
	$menu;
}

### subroutines ###
# the whole /read routine
###################

sub ReadThread {
	my($threadID)=@_;
	local($msgTUB)="$treeDIR$SL$threadID";	# need these in
	local(%msgDB,%msgStat);			# &OutputIndex and &ReadMsg
	my($sourcethreadID)=$threadDB{$threadID,"source\0"};

	&flocker::NewLockfile("$msgTUB$SL$msgDB");
	&flocker::flockSH("$msgTUB$SL$msgDB");
	unless (tie %msgDB,SDBM_File,"$msgTUB$SL$msgDB",O_RDONLY,0) {
		&flocker::flockUN("$msgTUB$SL$msgDB");
		&ErrServ("cannot access msgDB");
		&LogWarn("could not access msgDB for threadID $threadID: $!");
		&End;
	};

	&flocker::NewLockfile("$msgTUB$SL$markDB");
	&flocker::flockEX("$msgTUB$SL$markDB");
	unless (tie %markDB,SDBM_File,"$msgTUB$SL$markDB",O_CREAT|O_RDWR,$dbperms) {
		&flocker::flockUN("$msgTUB$SL$markDB");
		untie %msgDB;
		&flocker::flockUN("$msgTUB$SL$msgDB");
		&ErrServ("cannot access markDB");
		&LogWarn("could not access markDB for threadID $threadID: $!");
		&End;
	};
	my($lastread)=$markDB{"$uid\0"};
	$markDB{"$uid\0"}=$timestamp;
	untie %markDB;
	&flocker::flockUN("$msgTUB$SL$markDB");

	my($readform)=($in{'readform'} || $defreadform);
	my($domsgs,$doindx)=(($readform=~/msgs/),($readform=~/indx/));
	my($arenewmsgs)=($threadDB{$threadID,"timelast\0"} gt $lastread);

	&OutputTop('thread reader');
	&OutputNavButtons;

	print "<hr noshade size=3>\n";
	print "<h2>",$threadDB{$threadID,"subject\0"},"</h2>\n";
	&LinkSpawn($sourcethreadID,'from') if $sourcethreadID;

	print "<hr noshade size=3>\n";
	print "<center><table>\n";
	if ($doindx) {
		if ($arenewmsgs) {
			print "<tr><td><a href=\"#imark\">first new in index</a>";
		} else {
			print "<tr><td";
			print " rowspan=2" if $domsgs;
			print ">no new messages\n";
		};
		print "<td><a href=\"#",$threadDB{$threadID,"timefirst\0"},"\">first message</a>" if $domsgs;
		print "<td";
		print " rowspan=2" if $domsgs;
		print "><a href=\"#read\">switch threads</a>\n";
	};
	if ($domsgs) {
		if ($arenewmsgs) {
			print "<tr><td><a href=\"#pmark\">first new message</a>\n";
		} else {
			print ($doindx ? "<tr>" : "<tr><td>no new messages\n");
		};
	};
	print "<td><a href=\"#",$threadDB{$threadID,"timelast\0"},"\">last message</a>" if $domsgs;
	print "<td><a href=\"#read\">change threads</a>\n" unless $doindx;
	print "</table></center>\n";

	my($key,$value);
	while (($key,$value)=each %msgDB) {
	    $msgStat{$1}=$value if $key=~/^(\d+-\d+).status\0/;
	};

	if ($readform=~/indx/) {
		print "<hr noshade size=3>\n";
		&OutputIndex($threadID,($readform=~/msgs/),$lastread);
	};
	if ($readform=~/msgs/) {
		my($msgID,$status);
		my($first)=1;
		my($marked,$isNew)=(0,0);
		print "<hr noshade size=3>\n";
		foreach $msgID (sort keys %msgStat) {
			$status=$msgStat{$msgID};
			$first ? $first=0 : print "<hr>\n";
			$isNew=(($msgID gt $lastread) && ($status eq 'N'));
			if (!$marked && $isNew) {
				$marked++;
				print "<a name=\"pmark\"></a>";
			};
			&ReadMsg(
				$threadID,
				$msgID,
				$status,
				$msgDB{$msgID,"poster\0"},
				$msgDB{$msgID,"summary\0"},
				$readform,
				$isNew
			);
		};
	};

	untie %msgDB;
	&flocker::flockUN("$msgTUB$SL$msgDB");

	if ($auth{"post"} && $readform=~/msgs/) {
		print "<hr noshade size=3>\n";
		&OutputFormTag;
		print "<input type=hidden name=sourcethreadID value=$threadID>";
		print "<dl><dt>Response by ";
		$useAnonUser
			? print "anonymous guest"
			: print ( $userDB{$uid,"name\0"} || "(no name)" );
		print "</dt>\n";
		if ($auth{"new"}) {
			print <<EOHTML;
<dd><input type=radio name=threadID value=$threadID checked>
 Continue in the current thread
 (<b>$threadDB{$threadID,"subject\0"}</b>)</dd>
<dd><input type=radio name=threadID value=0>
 Begin a new thread named
 <input name=newthreadsubject size=30 maxlength=30></dd>
EOHTML
		} else {
			print <<EOHTML;
<dd><input type=hidden name=threadID value=$threadID>
Continue in the current thread (<b>$threadDB{$threadID,"subject\0"}</b>)</dd>
EOHTML
		};
		print "</dl>\n";
		&OutputMsgArea;
		print "</form>";
	};

	&OutputReadThread($threadID) if $auth{'read'};
	&OutputBot(0);
}

sub ReadMsg {
	my($threadID,$msgID,$msgStatus,$posteruid,$summary,$readform,$isNew)=@_;
	my($poster,$replylink,$when);


	if ($replylink=$userDB{$posteruid,"email\0"}) {	# has email address?
		$poster=( $userDB{$posteruid,"name\0"} || $replylink );
		$poster="\<a href=\"mailto:$replylink\"\>$poster\</a\>";
	} else {
		$poster=$userDB{$posteruid,"name\0"};
	};

	print "<a name=\"$msgID\"></a>\n";			# anchor

	print "<table width=\"100%\"><tr><td align=left>$poster\n";

	if ( ( ( $auth{'unpost'} && $uid==$posteruid ) || $auth{'admin'} ) && $msgStatus eq "N" ) {
		print "<td>";
		&OutputFormTag;
		print "<td align=center>";
		&OutputButton('unpost','/unpost');
		print "<input type=hidden name=threadID value=$threadID>";
		print "<input type=hidden name=msgID value=$msgID>\n";
		print "<td></form>";
	};
	$when=strftime($msgtimestamp,localtime( (split("-",$msgID,2))[0] ));
	$when="<b>".$when."</b>" if $isNew;
	print "<td align=right>",$when,"</table>\n";

	print "<p>Summary: <b>",$summary,"</b></p>\n" if $summary ne '';

	if ($msgStatus eq "N") {
		open (MSG,"<$msgTUB$SL$msgID");			# output
		print "<p>",<MSG>,"</p>\n";			# the
		close(MSG);					# message
	} elsif ($msgStatus eq "S") {
		print "<p><i>inactivated</i></p>\n";
	} elsif ($msgStatus eq "R") {
		print "<p><i>reactivated</i></p>\n";
	} elsif ($msgStatus=~/^U-(\d+)-(\d+-\d+)$/) {
		my($Uuid,$Utimestamp)=($1,$2);
		print "<p><i>unposted on ",strftime($msgtimestamp,localtime( (split("-",$Utimestamp,2))[0] ))," by ";
		if ($Uuid==$posteruid) {
			print "poster";
		} else {
			print ($userDB{$Uuid,"name\0"} || "(no name)");
		};
		print "</i></p>\n";
	} elsif ($msgStatus=~/^C-(\d+)$/) {
		&LinkSpawn($1,'into');
	};
}

sub OutputIndex {
	my($threadID,$msgs,$lastread)=@_;
	my($msgID,$msgnum);
	my($marked,$datebeg,$dateend);

	print "<h2>Index of messages</h2>\n";
	print "<table width=\"90%\">\n";

	foreach $msgID (sort keys %msgStat) {
		if (($msgID gt $lastread) && ($msgStat{$msgID} eq 'N')) {
			if (!$marked) {
				$marked++;
				print "<tr><td colspan=4><a name=\"imark\"></a>";
				print "<hr>" if $msgnum;
			};
			($datebeg,$dateend)=('<b>','</b>');
		} else {
			($datebeg,$dateend)=('','');
		};
		print "<tr><th valign=top>";
		$msgs
			? print "<a href=\"#$msgID\">",++$msgnum,"</a></th>"
			: print ++$msgnum,"</th>";
		print "<td valign=top>",($msgDB{$msgID,"summary\0"}||"<i>(none)</i>");
		print "<br><td valign=top nowrap>",$userDB{$msgDB{$msgID,"poster\0"},"name\0"};
		print "<br><td valign=top nowrap><code>",$datebeg;
		print strftime($shorttimestamp,localtime( (split("-",$msgID,2))[0] ));
		print $dateend,"</code><br>\n";
	};
	print "</table></ol>\n";
}

### subroutines ###
# create threads and post messages
###################
sub CreateThread {
	$in{'threadID'}=++$threadDB{"countall\0"};
	local($msgTUB)="$treeDIR$SL$in{'threadID'}";
	$threadDB{"count+++\0"}++;

	&EscapeHTML($in{'newthreadsubject'});
	$threadDB{$in{'threadID'},"status\0"}="new";
	$threadDB{$in{'threadID'},"source\0"}=$in{'sourcethreadID'};
	$threadDB{$in{'threadID'},"subject\0"}=$in{'newthreadsubject'};
	$threadDB{$in{'threadID'},"timefirst\0"}=$timestamp;

	unless (mkdir("$msgTUB",$dirperms)) {		# set up
		&ErrServ("cannot create thread");	# the thread
		&LogWarn("cannot create $msgTUB: $!");
		&End;
	};
}

sub PostMessageCheck {			# error if thread not active
	local($threadID,$statusflag,%post)=@_;
	unless ( ($threadDB{$threadID,"status\0"}>0) || ($threadDB{$threadID,"status\0"} eq "new") ) {
		&ErrUser("that thread is inactive or has been removed from the server");
		&End;
	};
	&PostMessage($threadID,$statusflag,%post);
}

sub PostMessage {			# posts the message in %post
	local($threadID,$statusflag,%post)=@_;
	local($msgTUB)="$treeDIR$SL$threadID";
	local(%msgDB);
	local($msgID)=$timestamp;

	unless (open(MSG,">$msgTUB$SL$msgID")) {
		&ErrServ("cannot post your message");
		&LogWarn("cannot create $msgTUB$SL$msgID: $!");
		&End;
	};

	&flocker::NewLockfile("$msgTUB$SL$msgDB");
	&flocker::flockEX("$msgTUB$SL$msgDB");
	unless (tie %msgDB,SDBM_File,"$msgTUB$SL$msgDB",O_CREAT|O_RDWR,$dbperms) {
		&flocker::flockUN("$msgTUB$SL$msgDB");
		close(MSG);
		&ErrServ("cannot access msgDB");
		&LogWarn("could not access msgDB for threadID $threadID: $!");
		&End;
	};

	$msgDB{$msgID,"poster\0"}=$uid;
	$msgDB{$msgID,"summary\0"}=$post{'summary'};
	$msgDB{$msgID,"status\0"}=$statusflag;
	untie %msgDB;
	&flocker::flockUN("$msgTUB$SL$msgDB");

	print MSG $post{'msg'};
	close(MSG);

	$threadDB{$threadID,"status\0"}+=1;	# ++ would make "new" -> "nex"
}

### subroutines ###
# userDBinteraction
###################
sub UpdateUserDB {		# modifies $_[0]=uid according to %in
	my($targetuid)=$_[0];

	&ChangeUname($targetuid,$in{'user'});
	&PWSet($targetuid,$in{'pw1'}) if $in{'pw1'};
	&SetAuth($targetuid,$in{'auth'});
	$userDB{$targetuid,"name\0"}=$in{'name'};
	$userDB{$targetuid,"email\0"}=$in{'email'};
}

### subroutines ###
# $myURL
###################
sub OutputBeginNew {
	print "<hr noshade size=3>\n";
	print "<h2>Begin a new thread</h2>\n";
	&OutputFormTag;
	print "<input type=hidden name=sourcethreadID value=0>";
	print "<dl><dt>New thread by ";
	$useAnonUser
		? print "anonymous guest"
		: print ( $userDB{$uid,"name\0"} || "(no name)" );
	print "</dt>\n";
	print <<EOHTML;
<dd><input type=hidden name=threadID value=0>
 Begin a new thread named
 <input name=newthreadsubject size=30 maxlength=30></dd>
</dl>
EOHTML
	&OutputMsgArea;
	print "</form>";
}

sub OutputMainOpts {
	my(@opts,$optAction);
	push(@opts,"user","Modify your user information<input type=hidden name=targetuid value=$uid>") if $auth{"user"};
	push(@opts,"globalauth","Modify global (conference-wide) authorizations") if $auth{"superuser"};
	push(@opts,"superuser","Modify other users' information") if $auth{"superuser"};
	push(@opts,"ticklist","View the ticket registry") if $auth{"superuser"} || $auth{"admin"};
	push(@opts,"adduser","Add a new user") if $auth{"adduser"};
	push(@opts,"admin","Manage threads") if $auth{"admin"};

	if (@opts) {
		print "<hr noshade size=3>\n";
		print "<h2>Other functions</h2>\n";
		&OutputFormTag;
#		print "<input type=hidden name=function value=ON>\n";
		while ($optAction=shift @opts) {
			&OutputButton("M$optAction","/$optAction");
			print " ",shift(@opts),"<br>\n";
		};
		print "</form>\n";
	};
}

### subroutines ###
# $myURL/admin
###################
sub OutputAdmin {
	print <<EOHTML;
<h2>Greetings, admin</h2>
<hr noshade size=3>

<center>
<h3>inactivate and activate threads</h3>
</center>

This section allows you to make threads <i>active</i> or 
<i>inactive</i>. Select the threads that you wish to switch. 
<i>Active</i> threads can be read and posted to, while 
<i>inactive</i> ones are invisible (except on this page). 
In addition, only <i>inactive</i> threads can be deleted 
(see next section).
EOHTML

	print "<table width=\"100%\"><tr align=center><td>\n";
	&OutputFormTag;
	print "<th width=\"50%\">currently active";
	print "<th width=\"50%\">currently inactive</tr><br>";
	print "<tr align=center valign=top><td><td>\n";
	&ThreadMenu(1,"susIDs","multiple size=10") || print "(none)\n";
	print "<td>\n";
	&ThreadMenu(-1,"resIDs","multiple size=10") || print "(none)\n";;
	print "</tr><br>\n";

	print "<tr align=center><td>";
	print "<td>(highlighted threads<br>will become inactive)<br>";
	print "<td>(highlighted threads<br>will become active)<br>";
	print "<tr align=center><td colspan=3>";
	&OutputButton('susres','/admin/susres');

	print <<EOHTML;

<br><input type=reset value=clear><br>
<td></form>
</table>

<hr noshade size=3>

<center>
<h3>delete threads</h3>
</center>

This section allows you to delete (permanently remove) threads. Select 
the threads that you wish to delete Note that only <i>inactive</i> 
threads can be deleted (see the above section).
EOHTML

	print "<table width=\"100%\"><tr align=center><td>\n";
	&OutputFormTag;
	print "<th>currently inactive</tr><br>";
	print "<tr align=center valign=top><td><td>\n";
	&ThreadMenu(-1,"delIDs","multiple size=10") || print "(none)\n";
	print "</tr><br>\n";

	print "<tr align=center><td>";
	print "<td>(highlighted threads<br>will be deleted)<br>";
	print "<tr align=center><td colspan=2>";
	&OutputButton('delete','/admin/delete');
	print "<br><input type=reset value=clear><br>";
	print "<td></form></table>\n";
}

sub Action_susres {
	@sus=split(/\0/,$in{'susIDs'});
	@res=split(/\0/,$in{'resIDs'});
	if (grep(/\D/,@sus,@res)) {
		&ErrHack("invalid threadID");
		&LogHack("bad threadID passed to /admin/susres");
		&End;
	};
	if (grep($threadDB{$_,"status\0"}==0,@sus,@res)) {
		&ErrUser("cannot susres a thread that has been deleted");
		&End;
	};
	grep(&SusThread($_),@sus);
	grep(&ResThread($_),@res);
}

sub SusThread {
	if ($threadDB{$_[0],"status\0"}>0) {
		$post{'summary'}='';
		$post{'msg'}='';
		&PostMessage($_[0],"S",%post);

		$threadDB{$_[0],"status\0"}*=-1;
		$threadDB{"count+++\0"}--;
		$threadDB{"count---\0"}++;
	};
}

sub ResThread {
	if ($threadDB{$_[0],"status\0"}<0) {
		$post{'summary'}='';
		$post{'msg'}='';
		&PostMessage($_[0],"R",%post);

		$threadDB{$_[0],"status\0"}*=-1;
		$threadDB{"count---\0"}--;
		$threadDB{"count+++\0"}++;
	};
}

### subroutines ###
# $myURL/admin/delete
###################
sub Action_delete {
	@del=split(/\0/,$in{'delIDs'});
	if (grep(/\D/,@del)) {
		&ErrHack("invalid threadID");
		&LogHack("bad threadID passed to /admin/delete");
		&End;
	};
	if (grep($threadDB{$_,"status\0"}>0,@del)) {
		&ErrUser("cannot delete a thread that is still active");
		&End;
	};
	grep(&DelThread($_),@del);
}

sub DelThread {
	local($msgTUB)="$treeDIR$SL$_[0]";
	if ($threadDB{$_[0],"status\0"}<0) {
		$threadDB{$_[0],"status\0"}=0;
		$threadDB{"count---\0"}--;
		$threadDB{"count000\0"}++;
		unlink <$msgTUB$SL*>;
		rmdir($msgTUB);
	};
}

### subroutines ###
# $myURL/unpost
###################
sub Action_unpost {
	local($threadID,$msgID)=@_;
	local($msgTUB)="$treeDIR$SL$threadID";
	local(%msgDB);

	&flocker::NewLockfile("$msgTUB$SL$msgDB");
	&flocker::flockEX("$msgTUB$SL$msgDB");
	unless (tie %msgDB,SDBM_File,"$msgTUB$SL$msgDB",O_RDWR,0) {
		&flocker::flockUN("$msgTUB$SL$msgDB");
		&ErrServ("cannot access msgDB");
		&LogWarn("could not access msgDB for threadID $threadID: $!");
		&End;
	};

	unless ($auth{'admin'} || $uid==$msgDB{$msgID,"poster\0"}) {
		untie %msgDB;
		&flocker::flockUN("$msgTUB$SL$msgDB");
		&ErrHack("you can only unpost a message you posted");
		&LogHack("user attempted to unpost someone else's message");
		&End;
	};

	unless ($msgDB{$msgID,"status\0"} eq "N") {
		untie %msgDB;
		&flocker::flockUN("$msgTUB$SL$msgDB");
		&ErrHack("you cannot unpost that type of message");
		&LogHack("user attempted to unpost a non-post message");
		&End;
	};

	unless (rename("$msgTUB$SL$msgID","$msgTUB$SL$msgID-unposted")) {
		&LogWarn("could not rename $msgTUB$SL$msgID to $msgTUB$SL$msgID-unposted for unpost");
	};

	$msgDB{$msgID,"summary\0"}="";
	$msgDB{$msgID,"status\0"}="U-$uid-$timestamp";

	untie %msgDB;
	&flocker::flockUN("$msgTUB$SL$msgDB");

}

### subroutines ###
# $myURL/user/set
###################
sub Action_set {
	my($uname)=&LookupUname($uid);		# person making the changes
	&PWCheck($uname,$in{'passwd'},'/user/set');

	if (!$auth{'superuser'} && ($in{'user'} ne $uname)) {
		&ErrHack("you are not permitted to change that field");
		&LogHack("user attempted to change the userDB:user field");
		&End;
	};
	if (($in{'user'} ne &LookupUname($in{'targetuid'})) && &LookupUID($in{'user'})) {
		&ErrUser("the username $in{'user'} is already taken","please use something different");
		&End;
	};

	if (!$auth{"superuser"} && ($in{'targetuid'} ne $uid)) {
		&ErrHack("you are not permitted to change that field");
		&LogHack("user attempted to change the userDB:uid field");
		&End;
	};

	&SanityCheck;

	&SetNumFromCB('auth');
	if (!$auth{'superuser'} && ($in{'auth'} ne &GetAuth($in{'targetuid'}))) {
		&ErrHack("you are not permitted to change that field");
		&LogHack("user attempted to change the userDB:auth field");
		&End;
	};
	&UpdateUserDB($in{'targetuid'});
}

### subroutines ###
# $MyURL/adduser
###################
sub OutputAddUser {
	&CatFile("$treeDIR$SL$addHTML");
	print "<hr noshade size=3>\n";
	&OutputFormTag;
	print <<EOHTML;

<pre>
   username:  <input name=user>

   password:  <input type=password name=pw1>
              <input type=password name=pw2> (re-enter to verify)

EOHTML
	print "   uid:       will be assigned\n\n" if $auth{'superuser'};
	&OutputAuthFlags($auth{'superuser'},'default');
	print <<EOHTML;

   name:      <input name=name size=40>

   email:     <input name=email size=40>

EOHTML
	&OutputButton('Aadd','/adduser/new');
	print "<input type=reset value=clear>\n</pre></form>\n";

}

sub AddUser {

	if ($in{'user'} eq '' || $in{'pw1'} eq '') {
		&ErrUser("you must at least enter a username and password");
		&End;
	};
	if (&LookupUID($in{'user'})) {
		&ErrUser("the username $in{'user'} is already taken","please use something different");
		&End;
	};
	&SanityCheck;

	my($newuid)=&AddUserPass($in{'user'},$in{'pw1'});

	&SetAuth($newuid,$in{'auth'});
	$userDB{$newuid,"name\0"}=$in{'name'};
	$userDB{$newuid,"email\0"}=$in{'email'};

	$in{'targetuid'}=$newuid;
}

sub OutputUserAdded {
	print "login for $in{'user'} has been added.<br>\n";
	if ($auth{"superuser"}) {
		&OutputFormTag;
		print "<input type=hidden name=targetuid value=$in{'targetuid'}>";
		&OutputButton('Auser','/user');
		print " Edit this user's entry<br>\n";
		&OutputButton('Aagain','/adduser');
		print " Add another user<br></form>\n";
	};
}

### subroutines ###
# check certain input fields for validity
###################
sub SanityCheck {
	if ( $in{'email'} && ( !($in{'email'}=~/^.+@.+$/) || ($in{'email'}=~/\s/) ) ) {
		&ErrUser("that email address does not appear to be valid");
		&End;
	};

	if ( "$in{'login'} $in{'name'} $in{'email'}"=~/[<>&"]/ ) {
		&ErrUser("you cannot have the characters &lt; &gt; &amp; &quot; in your login, name, or email address");
		&End;
	};

	if ($in{'pw1'} ne $in{'pw2'}) {
		&ErrUser("new passwords do not match");
		&End;
	};
}

### subroutines ###
# $myURL/globalauth
###################
sub OutputGlobalAuths {
	print <<EOHTML;

<center>
<h3>Global user authorization control</h3>
</center>

<p>This section allows you to specify default authorizations for newly 
added users, as well as universally grant or deny certain priviledges. For 
each priviledge, you can choose:
<ul>
	<li>&quot;give&quot; this authorization to all users, regardless of thier own authorizations
	<li>&quot;user&quot; authorizations (no change)
	<li>&quot;deny&quot; this authorization to all users, regardless of their own authorizations
</ul>

Checking the checkbox for a permission will grant that permission to 
new users as they are added (provided it is not denied to all users 
with a &quot;deny&quot; mask). Click &quot;reset&quot; to restore the 
currently saved preferences.</p>

EOHTML

	&OutputFormTag;
	&OutputSUAuth;
	print "<table width=\"90%\"><tr align=center>";
	&OutputButton('Sglobal','/globalauth/setauthdefs');
	print "<input type=reset value=reset></table></center></form>\n";
}

### subroutines ###
# $myURL/superuser
###################
sub OutputSuperUser {
	print <<EOHTML;
<h2>Greetings, superuser</h2>

<hr noshade size=3>

<center>
<h3>Edit individual user</h3>
</center>

<p>Select a user to edit from <em>one</em> catagory below. Selected 
blanks (the first item in each menu) will be disregarded.</p>

EOHTML

	my($numusers)=&NumUsers;
	my($targetuid,%targetinfo,$targetinfo,$menu);

	use Sort::PolySort;
	my $s = new Sort::PolySort;

	&OutputFormTag;
	print "<center><table>";
	print "<tr><th>uid<th>login<th>name<th>email<tr>\n";

	$menu=length(&NumUsers);
	print "<td align=center valign=top>";			# by uid
	print "<input name=targetuid size=$menu maxlength=$menu>\n";

	print "<td align=center valign=top>";			# by uname
	print "<select multiple name=targetuid size=10><option value=0> \n";
	do {
		($targetuid,$targetinfo)=&EachUser; 
	} while $targetinfo{$targetinfo}=$targetuid;
	delete $targetinfo{''};
	foreach $targetinfo (sort keys %targetinfo) {
		print "<option value=$targetinfo{$targetinfo}>$targetinfo\n";
	};
	print "</select>\n";

	%targetinfo=();
	print "<td align=center valign=top>";			# by name
	for ($targetuid=1;$targetuid<=$numusers;$targetuid++) {
		next unless $targetinfo=$userDB{$targetuid,"name\0"};
		$targetinfo{$targetinfo}=$targetuid;
	};
	if (%targetinfo) {
		print "<select multiple name=targetuid size=10><option value=0> \n";
		foreach $targetinfo ($s->sortby('name',keys %targetinfo)) {
			print "<option value=$targetinfo{$targetinfo}>$targetinfo\n";
		};
		print "</select>\n";
	};

	%targetinfo=();
	print "<td align=center valign=top>";			# by email
	for ($targetuid=1;$targetuid<=$numusers;$targetuid++) {
		next unless $targetinfo=$userDB{$targetuid,"email\0"};
		$targetinfo{$targetinfo}=$targetuid;
	};
	if (%targetinfo) {
		print "<select multiple name=targetuid size=10><option value=0> \n";
		foreach $targetinfo ($s->sortby('email',keys %targetinfo)) {
			print "<option value=$targetinfo{$targetinfo}>$targetinfo\n";
		};
		print "</select>\n";
	};

	print "</table><table width=\"90%\"><tr align=center>";
 	&OutputButton('Suser','/user');
	print "<input type=reset value=clear></table></center></form>\n";
}

### subroutines ###
# main login screen
###################
sub OutputLogin {
	&CatFile("$treeDIR$SL$loginHTML");
	print "<hr noshade size=3>\n";
	print "<h3>WebThread login:</h3>\n";
	$in{'no-gen-ticket'}='ON';
	&OutputFormTag;
	print "<pre>\n";
	print "   username:  <input name=login-name>\n";
	print "   password:  <input type=password name=login-pass>\n";
	print "              ";
	&OutputButton('login');
	print "\n</pre>\n";
	print "</form>\n";
	print "<hr noshade size=3>\n";
	print "<a href=\"$exitURL\">Leave</a> WebThread<br>\n";
}

sub OutputFormTag {	# <form> tag
	my($action)="$myURL";

	&NewTicket($uid) unless ($in{'no-gen-ticket'} || $newTicket);

	my($readform)=($in{'readform'} || $defreadform);
	my($callfrom)=(caller(1))[3];

	print "<form method=\"post\" action=$action>\n";
	print "<input type=hidden name=ticket value=$newTicket>\n" if $newTicket;
	print "<input type=hidden name=readform value=$readform>\n" unless $callfrom=~/(OutputReadThread|OutputLogin)/;
}

sub LinkSpawn {
	my($spawnthreadID,$how)=@_;
	my($subject)=$threadDB{$spawnthreadID,"subject\0"};
	my($exists)=($threadDB{$spawnthreadID,"status\0"}>0);

	&OutputFormTag if $exists;
	print "<i>continued $how thread &quot;$subject&quot;</i>";
	if ($exists) {
		&OutputButton('spawn','/read');
		print "<input type=hidden name=threadID value=$spawnthreadID>";
		print "</form>\n";
	} else {
		print "<br>\n";
	};
}

sub CatFile {
	my($source)=@_;
	open(FILE,"<$source");
	print <FILE>;
	close(FILE);
}

### subroutines ###
# protect characters with special html meaning
###################
sub EscapeHTML {
	my($string)=@_;

	$string=$query->escapeHTML($string);	# protect special html chars

	$string=~s/\015\012/\n/g;		# various browser/server
	$string=~s/\r\n/\n/g;			# combinations might yield
	$string=~s/\r/\n/g;			# different end-of-lines

	$string=~s/\n/<br>\n/g;			# convert 'em all to html

	$_[0]=$string;
}

