package WT::ticket;

# library of ticket handling-routines for WebThread
# $Id: ticket.pm,v 2.4 1996/10/06 19:47:17 dmacks Rel $

# WebThread, a hacked together cgi-bin thingy by Daniel Macks
# This file copyright (c) 1996 by Emaze Software Corp. and Daniel Macks.
# All rights reserved. See the file COPYRITE for more information.

#use strict;

use WT::errors;

### constructor ###
# define filenames and other constants
###################
$WT::ticket::ticketTUB="$ENV{'projectDIR'}${main::SL}tickets";
$WT::ticket::dirperms=$main::dirperms;
&CreateTicketRegistry;	# in case some bonehead deleted it

### private routines ###
# returns filename corresponding to the given ticket
########################
sub TickFile {
	my($userticket)=@_;
	my($stuff,$pid,$salt)=$userticket=~/^(\d+-\d+)-(\d+)-(..)$/;

	my $cryptpid = crypt($pid,$salt);
	$cryptpid=~s/[^A-Za-z0-9_]/_/g;	# so not get special filename chars

	"$WT::ticket::ticketTUB$main::SL$stuff-$cryptpid";
}

### private routines ###
# creates ticket registry if necessary
#######################
sub CreateTicketRegistry {
	return if (-d $WT::ticket::ticketTUB && -w _);
	unless (mkdir("$WT::ticket::ticketTUB",$WT::ticket::dirperms)) {
		&main::ErrServ("cannot create ticket registry");
		&main::LogWarn("cannot create $WT::ticket::ticketTUB: $!");
		&main::End;
	};
	chmod $WT::ticket::dirperms, $WT::ticket::ticketTUB;	# mkdir's fubar
}

### public routines ###
# returns uid from ticket, or false (0) if invalid ticket
#######################
sub main::ValidTicket {
	my($ticket)=@_;
	my($uid)=split('-',$ticket);

	$uid=0 unless $ticket=~/^\d+-\d+-\d+-..$/;	# sanity check
	$uid=0 unless -e &TickFile($ticket);		# ticket in registry?
	$uid=0 unless -o _;				# not forged?

	$uid;
}

### public routines ###
# delete given ticket
# generate new ticket (in global variable), save in registry
#######################
sub main::NewTicket {
	my($uid)=@_;

	&main::DeleteTicket($main::in{'ticket'});
	$main::newTicket = "$uid-$^T-$$-" . &NewSalt;
	my $tickfile = &TickFile($main::newTicket);

	unless (open(TICKET,">$tickfile")) {
		&main::ErrServ("could not create new ticket");
		&main::LogWarn("could not create ticket $tickfile: $!");
		&main::End;
	}
	print TICKET "$ENV{'REMOTE_ADDR'}:$ENV{'HTTP_USER_AGENT'}:\"$main::lnf_name\"\n";
	close(TICKET);
}

### public routines ###
# deletes the given ticket form the registry
#######################
sub main::DeleteTicket {
	unlink &TickFile($_[0]);
}

### public routines ###
# outputs html table of tickets
# if $_[0]>=0, deletes tickets older than that number of hours
#######################
sub main::OutputTicketRegistry {
	my $expdt = $_[0]*3600;
	my $doExpire = ($expdt>=0);
	my $numUsers = &main::NumUsers;
	my $format = '<td align=right><code>%d+ %.2d:%.2d:%.2d</code><br>';

	my($ticket,$tickuid,$tickage,@age);

	unless (opendir(TTUB,$WT::ticket::ticketTUB)) {
		&main::ErrServ("could not find tickets");
		&main::LogWarn("could not access ticket registry: $!");
		&main::End;
	};

	print "<center><h3>Active tickets</h3><table border>\n";
	print "<tr><th>uid<br></th><th>ticket</th><th>age<br></th><th>status<br></th>\n";
	while ($ticket=readdir(TTUB)) {
		next if $ticket eq '.' || $ticket eq '..';
		next unless $ticket=~/^(\d*)-(\d+)-.+$/;
		($tickuid,$tickage)=($1,$^T-$2);

		print "<tr><td><code>$tickuid</code><br>";
		print "<td><code>$ticket</code><br>";

		$age[3] = $tickage;
		$age[0] = int($age[3] / 86400);
		$age[3] -= $age[0] * 86400;
		$age[1] = int($age[3] / 3600);
		$age[3] -= $age[1] * 3600;
		$age[2] = int($age[3] / 60);
		$age[3] -= $age[2] * 60;
		printf $format,@age;

		print "<td><code>";
		if (&TickFile($main::in{'ticket'})=~/$ticket$/) {
			print "this<br>";
		} elsif ($doExpire && $tickage>$expdt) {
			unlink "$WT::ticket::ticketTUB$main::SL$ticket";
			print "deleted<br>";
		};

		print "invalid<br>" if !$tickuid || $tickuid>$numUsers;
		print "</code>\n";

	};
	print "</table></center><hr>\n";
	closedir(TTUB);
}

### private routines ###
# create a salt (taken from camel perl book, p188 "functions: srand"
########################
sub NewSalt {
	my @saltset = ('a'..'z','A'..'Z','0'..'9','.','/');
	srand( time | $$ );
	$saltset[rand(@saltset)].$saltset[rand(@saltset)];
}


1;

